package com.codecaballero.proyectofinal;

import org.opencv.core.Point;

import java.util.ArrayList;
import java.util.Collections;

/**
 * Created by android on 14/09/15.
 */
public class BufferCasillas {
    private static BufferCasillas mInstance = null;



    private ArrayList<MiCasilla> bufferCasillas = new ArrayList<>(); //Corregidas

    private ArrayList<MiCasilla> bufferCasillasParaCorregir = new ArrayList<>();

    public ArrayList<MiCasilla> getBufferCasillasParaCorregir() {
        return bufferCasillasParaCorregir;
    }



    public static BufferCasillas getInstancia(){
        if (mInstance==null)
        {
            mInstance = new BufferCasillas();
        }
        return mInstance;
    }



    public void clears(){
        if (!bufferCasillas.isEmpty())
            bufferCasillas.clear();
    }

    public void clearCasillas(){
        if (!bufferCasillasParaCorregir.isEmpty())
            bufferCasillasParaCorregir.clear();
    }

    public ArrayList<MiCasilla> getBufferCasillas(){
        return bufferCasillas;
    }


    public void addOrdenMiCuadradoModelo(MiCasilla miCasilla) {
        Point centro = miCasilla.getCentro();
        double x = centro.x;
        double y = centro.y;
        if (bufferCasillas.isEmpty()) {
            bufferCasillas.add(miCasilla);
        }else
        {
            for (int i = 0; i < bufferCasillas.size(); i++)
            {
                if (!esMayor(miCasilla.getCentro().x , bufferCasillas.get(i).getCentro().x))
                {
                    //bufferCasillas.add(i, miCasilla);
                    if (!esMayor(miCasilla.getCentro().y, bufferCasillas.get(i).getCentro().y))
                    {
                        bufferCasillas.add(i, miCasilla);
                        return;
                    }
                }


            }
            bufferCasillas.add(miCasilla);
        }
    }
    private boolean esMayor(double p,double s){
        return (s-p) > 8;

    }

    public void addOrdenCasillaParaCorregir(MiCasilla miCasilla) {
        Point centro = miCasilla.getCentro();
        double x = centro.x;
        double y = centro.y;
        if (bufferCasillasParaCorregir.isEmpty()) {
            bufferCasillasParaCorregir.add(miCasilla);
        }else
        {
            for (int i = 0; i < bufferCasillasParaCorregir.size(); i++)
            {
                if (!esMayor(miCasilla.getCentro().x , bufferCasillasParaCorregir.get(i).getCentro().x))
                {
                    //bufferCasillas.add(i, miCasilla);
                    if (!esMayor(miCasilla.getCentro().y , bufferCasillasParaCorregir.get(i).getCentro().y))
                    {
                        bufferCasillasParaCorregir.add(i, miCasilla);
                        return;
                    }
                }


            }
            bufferCasillasParaCorregir.add(miCasilla);
        }
    }

    public void setBufferCasillas(ArrayList<MiCasilla> bufferCasillas)
    {
        this.bufferCasillas = bufferCasillas;
    }




}
