package com.codecaballero.proyectofinal;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.Toast;

import org.opencv.android.BaseLoaderCallback;
import org.opencv.android.CameraBridgeViewBase;
import org.opencv.android.LoaderCallbackInterface;
import org.opencv.android.OpenCVLoader;
import org.opencv.core.Mat;

import java.util.ArrayList;


public class ModeloActivity extends Activity implements CameraBridgeViewBase.CvCameraViewListener2 {

    private static final String TAG = "ModeloActivity";
    private CameraBridgeViewBase cameraView;

    private boolean botonHaSidoPulsado = false;

    private ProcesadorModelo procesador;
    private Mat imagenRecurso_;
    private int cam_anchura = 640;//480;//800;// resolucion deseada de la imagen
    private int cam_altura= 480;//300;//480;

    Button button;
    BufferCasillas buffer;

    ArrayList<MiCasilla> array = new ArrayList<>();
    private BaseLoaderCallback loaderCallback = new BaseLoaderCallback(this) {
        @Override
        public void onManagerConnected(int status) {
            switch (status) {
                case LoaderCallbackInterface.SUCCESS:
                    Log.i(TAG, "OpenCV se cargo correctamente");
                    //Log.i(TAG, "OpenCV se cargo correctamente");
                    cameraView.setMaxFrameSize(cam_anchura, cam_altura);
                    cameraView.enableView();
                    break;
                default:
                    super.onManagerConnected(status);
                    break;
            }
        }
    };


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        setContentView(R.layout.activity_main);

        buffer = BufferCasillas.getInstancia();

        button = (Button)findViewById(R.id.button);
        cameraView = (CameraBridgeViewBase) findViewById(R.id.vista_camara);
        cameraView.setCvCameraViewListener(this);

    }
    @Override
    public void onPause() {
        super.onPause();
        if (cameraView != null)
            cameraView.disableView();
    }

    @Override
    public void onResume() {
        super.onResume();
        OpenCVLoader.initAsync(OpenCVLoader.OPENCV_VERSION_2_4_9, this, loaderCallback);
    }
    @Override
    public void onDestroy() {
        super.onDestroy();
        if (cameraView != null)
            cameraView.disableView();
    }

    //Interface CvCameraViewListener2
    public void onCameraViewStarted(int width, int height) {

        procesador = new ProcesadorModelo();

    }

    public void onCameraViewStopped() {
    }

    public Mat onCameraFrame(CameraBridgeViewBase.CvCameraViewFrame inputFrame) {
        Mat entrada,salida;
        entrada = inputFrame.gray();//entrada en color
        //Leemos desde un fichero
        //salida = procesador.procesa(procesaRAW(entrada));
        salida = procesador.procesa((entrada));




        runOnUiThread(new Runnable() {
            @Override
            public void run() {



                button.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        botonHaSidoPulsado = true;
                       /* if (ArchivoXML.crearXML(ModeloActivity.this,singleton2.getMiListaCuadradosModelo())) {
                            Toast.makeText(ModeloActivity.this, "ArchivoXML creado", Toast.LENGTH_SHORT).show();
                            ArchivoXML.getXYFromXml(ModeloActivity.this,array);
                            finish();
                        }*/
                    }
                });
            }
        });

        if (botonHaSidoPulsado)
        {
           // buffer.ordenarCasillas();
            //if (ArchivoXML.crearXML(ModeloActivity.this,singleton2.getMiListaCuadradosModelo()))
            if (ArchivoXML.crearXML(ModeloActivity.this, buffer.getBufferCasillas())) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(ModeloActivity.this, "ArchivoXML creado", Toast.LENGTH_SHORT).show();
                        finish();
                    }
                });
            }
            //ArrayList<MiCasilla> array = ArchivoXML.getXYFromXml(ModeloActivity.this,buffer.getBufferCasillas());

        }
        return salida;
    }


}
